unit Freer;

interface

uses Classes, ExtCtrls, Menus, StdCtrls, Buttons,
     Controls, TabNotBk, Forms, ToolHelp, SysUtils,
     WinTypes, Dialogs, WinProcs, Ver, Graphics, Grids, Inifiles,
     Printers, Spin, Stress,Gauges, Resgauge,About;

type
  TDLLS = class(TForm)
    PopupMenu: TPopupMenu;
    Remove: TMenuItem;
    TabbedNotebook1: TTabbedNotebook;
    Label1: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    ListBox1: TListBox;
    Label8: TLabel;
    ProgramVendorlabel: TMemo;
    InternalNameLabel: TMemo;
    FileVersionLabel: TMemo;
    FileDescriptionlabel: TMemo;
    CommentsLabel: TMemo;
    MainMenu1: TMainMenu;
    About1: TMenuItem;
    Print1: TMenuItem;
    Options1: TMenuItem;
    StayonTop1: TMenuItem;
    Donotstayontop1: TMenuItem;
    CheckDLL: TBitBtn;
    BitBtn1: TBitBtn;
    ModulesTypes: TRadioGroup;
    Panel1: TPanel;
    GDILabel: TLabel;
    SystemLabel: TLabel;
    UserLabel: TLabel;
    DrivePanel: TPanel;
    DriveGrid: TStringGrid;
    Label2: TLabel;
    Label4: TLabel;
    CPUType: TEdit;
    MathCo: TEdit;
    WindowsMode: TEdit;
    PagedMemory: TEdit;
    KeyboardType: TEdit;
    NumberOfKeys: TEdit;
    WinDir: TEdit;
    Label6: TLabel;
    FreeFileHandles: TEdit;
    FileHandlesLabel: TLabel;
    hgResourceGauge1: ThgResourceGauge;
    hgResourceGauge2: ThgResourceGauge;
    hgResourceGauge3: ThgResourceGauge;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ModulesTypesClick(Sender: TObject);
    procedure PopupMenuPopup(Sender: TObject);
    procedure RemoveClick(Sender: TObject);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListBox1Click(Sender: TObject);
    procedure CheckDLLClick(Sender: TObject);
    Procedure CloseButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure About1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    Function  GetFileVersion (pThisModule: String): String;
    procedure StayonTop1Click(Sender: TObject);
    procedure Donotstayontop1Click(Sender: TObject);
    Procedure FindDrives;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    VersionPanel    :Tpanel;
    CloseButton     :TBitBtn;
    VersionStringGrid  :TStringGrid;
    fStress         : Boolean;
  end;
  TFileHandles 	=function : Integer;

var
  DLLS: TDLLS;
  FileHandles :TFileHandles;
  curhan      :THandle;

implementation

{$R *.DFM}

procedure TDLLS.FormActivate(Sender: TObject);
var
    me      : TModuleEntry;
    pIniFile               :TiniFile;
    pListofDLLs            :TStringList;
    Counter                :Integer;
    pListofVers            :TStringList;
    pThisFile              :Pchar;
    pVersionHandle         :LongInt;
    pInformation           :Pchar;
    pFileVersion           :String;
    VersionInfoSize        :LongInt;
    pc                     :array[0..300] of char;
    pRet                   :pchar;
    cbRet                  :Word;
    SubCounter             :Integer;
    CurrentFile            :String;
    CurrentDirectory       :String;
begin
    me.dwSize := Sizeof(me);
    FindDrives;
    {Find First Loaded Module}

    if ModuleFirst(@me) then
    Begin
     ListBox1.Items.Add(UpperCase(strpas(me.szExePath)));
    end;

    {Repeat until end of Modules}
    While ModuleNext(@me) do
    Begin
        ListBox1.Items.Add(UpperCase(strpas(me.szExePath)));
    end;
    ListBox1.Update;
    CheckDLL.Visible:=True;
    {Determine if TeamWork.exe is loaded}
    if CheckDLL.Visible=True then BitBtn1.Height:=29 else BitBtn1.Height:=56;

    if CheckDLL.Visible=True then
    Begin
         {Find out from what directory you are running Modules.exe}
         For Counter:=0 to ListBox1.Items.Count-1 do
          if CompareStr(ExtractFileName(UpperCase(ListBox1.Items.Strings[Counter])),'MODULES.EXE')=0 then
           CurrentDirectory:=ExtractFilePath(ListBox1.Items.Strings[Counter]);
         VersionPanel:=TPanel.Create(DLLs);
         VersionPanel.parent:=DLLs;
         VersionPanel.Visible:=False;
         VersionPanel.Left:=5;
         VersionPanel.Top:=25;
         VersionPanel.Height:=347;
         VersionPanel.Width:=618;
         CloseButton:=TBitBtn.Create(VersionPanel);
         CloseButton.Parent:=VersionPanel;
         CloseButton.Top:=300;
         CloseButton.Left:=537;
         CloseButton.Width:=75;
         CloseButton.Kind:=bkOK;
         CloseButton.Caption:='OK';
         CloseButton.ModalResult:=mrOK;
         CloseButton.onClick:=CloseButtonClick;
         VersionStringGrid:=TstringGrid.Create(VersionPanel);
         With VersionStringGrid do
         Begin
             Parent:=VersionPanel;
             width:=525;
             Left:=45;
             Top:=20;
             Height:=270;
             ScrollBars:=ssVertical;
             ColCount:=4;
             ColWidths[0]:=250;
             ColWidths[1]:=100;
             ColWidths[2]:=100;
             ColWidths[3]:=50;
             DefaultRowHeight:=22;
             FixedRows:=1;
             FixedCols:=0;
             {Add Titles}
             Cells[0,0]:='DLL Name';
             Cells[1,0]:='INI Ver';
             Cells[2,0]:='Mem Ver';
             Cells[3,0]:='Check';
             {Fill in information provieded by the INI File}
             Try
                Try
                pIniFile:=TiniFile.Create(CurrentDirectory+'OptVer.ini');
                pListOfDlls:=TStringList.Create;
                pListOfVers:=TStringList.Create;
                {Read ini section into stringlist}
                pIniFile.ReadSection('Versions',pListOfDlls);
                {Set the StrigGrid Row Count to the number of enteries in the string list}
                RowCount:=pListOfDlls.Count+1;
                {Add names to StringGrid}
                For Counter:=0 to pListOFDlls.Count-1 do
                     Cells[0,Counter+1]:=pListOfDlls.Strings[Counter];
                {Get DLL Versions from INI File}
                pIniFile.ReadSectionValues('Versions',pListOfVers);
                {Add Values to String Grid}
                For Counter:=0 to pListOFDlls.Count-1 do
                     Cells[1,Counter+1]:=pListofvers.Values[pListOfDlls.Strings[Counter]];
                {Find Memory Version Information}
                For Counter:=0 to pListofDlls.Count-1 do
                Begin
                    pThisFile:=StrAlloc(300);
                    CurrentFile:='';
                    For SubCounter:=0 to ListBox1.Items.Count-1 do
                     if CompareStr(UpperCase(ExtractFilename(ListBox1.Items.Strings[SubCounter])),
                                   UpperCase(pListOfDlls.Strings[Counter]))=0 then
                                   CurrentFile:=ListBox1.Items.Strings[SubCounter];
                    if CurrentFile<>'' Then
                    Begin
                        StrPCopy(pThisFile,CurrentFile);
                        VersionInfoSize := GetFileVersionInfoSize(pThisFile,pVersionHandle);
                        if VersionInfoSize<>0 then
                        Begin
                           pInformation:= Stralloc(VersionInfoSize);
                            GetFileVersionInfo(pThisFile,pVersionHandle,VersionInfoSize,pInformation);
                            strcopy(pc, '\StringFileInfo\040904E4\FileVersion');
                            if VerQueryValue(pInformation, pc, pointer(pRet), cbRet) then
                             if cbRet>1 then
                              if strlen(pRet)>1 then Cells[2,Counter+1]:=Strpas(pRet);
                           StrDispose(pInformation);
                        end
                        else Cells[2,Counter+1]:='--';
                        StrDispose(pThisFile);
                    end;
                end;
                    {Evaluate the check field}
                    For Counter:=0 to VersionStringGrid.RowCount-1 do
                     if CompareStr(VersionStringGrid.Cells[1,Counter+1],VersionStringGrid.Cells[2,Counter+1])<>0 then
                      if VersionStringGrid.Cells[2,Counter+1]<>'' then VersionStringGrid.Cells[3,Counter+1]:='X' else
                         VersionStringGrid.Cells[3,Counter+1]:='NL';

                Except
                  on e:Exception do MessageDlg(E.Message,mtError,[mbOK],0);
                end;
             Finally
                    pIniFile.Free;
                    pListOfDlls.Free;
                    pListOfVers.Free;
             end;
         end;
    end; {if CheckDLL.Visible=True}
    {Get current file handles}
    if fStress then FreeFileHandles.Text:=IntToStr(FileHandles);
end;

procedure TDLLS.BitBtn1Click(Sender: TObject);
begin
Application.Terminate;
end;


procedure TDLLS.ModulesTypesClick(Sender: TObject);
var
    me          : TModuleEntry;
    pThisFile   : Pchar;
    pFileType   : Pchar;

begin
    ListBox1.Clear;
    if ModulesTypes.ItemIndex<>4 then
    Begin
        me.dwSize := Sizeof(me);
        {Find First Loaded Module}
        if ModuleFirst(@me) then
        Begin
            pFileType:=StrAlloc(300);
            pThisFile:=StrAlloc(300);
            StrPCopy(pThisFile,UpperCase(StrPas(me.szExePath)));
            StrPCopy(pFileType,ModulesTypes.Items.Strings[ModulesTypes.ItemIndex]);
            if StrPos(pThisFile, pFileType)<> nil then
                ListBox1.Items.Add(UpperCase(strpas(me.szExePath)));
            ListBox1.Update;
            StrDispose(pFileType);
            StrDispose(pThisFile);
        end;
        While ModuleNext(@me) do
        Begin
            pFileType:=StrAlloc(300);
            pThisFile:=StrAlloc(300);
            StrPCopy(pThisFile,UpperCase(StrPas(me.szExePath)));
            StrPCopy(pFileType,ModulesTypes.Items.Strings[ModulesTypes.ItemIndex]);
            if StrPos(pThisFile, pFileType)<> nil then
                ListBox1.Items.Add(UpperCase(strpas(me.szExePath)));
            ListBox1.Update;
            StrDispose(pFileType);
            StrDispose(pThisFile);
        end; {While}
    end {ItemIndex<>4}
    else FormActivate(self);
end;

procedure TDLLS.PopupMenuPopup(Sender: TObject);
begin
    If ListBox1.ItemIndex<>-1 then
        Remove.Enabled:=True
    else
        Remove.Enabled:=False;
end;

procedure TDLLS.RemoveClick(Sender: TObject);
Var
    mh           : THandle;
    me           : TModuleEntry;
    pThisModule  : Pchar;
    ThisModule   : String;
    SubString    : String;
    j            : Integer;
    fContinue    : Boolean;
begin
        fContinue:=True;
        me.dwSize := Sizeof(me);
        if MessageDlg('Are you sure that you want to remove this from memory?',mtConfirmation,[mbYes,mbNo],0)=mrYes then
        Begin
            {Get Module Name}
            if ModuleFirst(@me) then
            Begin
                if CompareStr(UpperCase(StrPas(me.szExePath)),Uppercase(ListBox1.Items.Strings[ListBox1.ItemIndex]))=0 then
                fContinue:=False
            end;
            if fContinue then
            Begin
                While ModuleNext(@me) do
                Begin
                    if CompareStr(Uppercase(StrPas(me.szExePath)),Uppercase(ListBox1.Items.Strings[ListBox1.ItemIndex]))=0 then
                    Begin
                        fContinue:=False;
                        Break;
                    end;
                end;
            end;
            if fContinue=False then
            Begin
                mh:=me.hModule;
                for j:=1 to me.wUsageFlags do
                 FreeModule(mh);
                ListBox1.Items.Delete(ListBox1.ItemIndex);
                ListBox1.Update;
            end;
            If fContinue then
             MessageDlg('The memory handle for this object could not be obtained.',mtInformation,[mbOK],0);
        end;
end;

procedure TDLLS.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if key=VK_DELETE then RemoveClick(Self);
end;

procedure TDLLS.ListBox1Click(Sender: TObject);
Var
   pThisFile              :Pchar;
   pVersionHandle         :LongInt;
   pInformation           :Pchar;
   VersionInfoSize        :LongInt;
   pc                     :array[0..300] of char;
   pRet                   :pchar;
   cbRet                  :Word;
   pInternalName          :String;
   pFileVersion           :String;
   pFileDescription       :String;
   pComments              :String;
   pVendor                :String;
begin
    InternalNameLabel.Clear;
    FileVersionLabel.Clear;
    FileDescriptionLabel.Clear;
    CommentsLabel.Clear;
    ProgramVendorLabel.Clear;

    pInternalName         :='N/A';
    pFileVersion          :='N/A';
    pFileDescription      :='N/A';
    pComments             :='N/A';
    pVendor               :='N/A';
    pThisFile:=StrAlloc(300);
    StrPCopy(pThisFile,ListBox1.Items.Strings[Listbox1.ItemIndex]);
    VersionInfoSize := GetFileVersionInfoSize(pThisFile,pVersionHandle);
    pInformation:= Stralloc(800);
    if VersionInfoSize<>0 then
    Begin
        GetFileVersionInfo(pThisFile,pVersionHandle,VersionInfoSize,pInformation);

        strcopy(pc, '\StringFileInfo\040904E4\CompanyName');
        if VerQueryValue(pInformation, pc, pointer(pRet), cbRet) then
         if cbRet>1 then
          if strlen(pRet)>1 then pVendor:=Strpas(pRet) else pVendor:='N/A'
         else pVendor:='N/A'
        else pVendor:='N/A';

        strcopy(pc, '\StringFileInfo\040904E4\InternalName');
        if VerQueryValue(pInformation, pc, pointer(pRet), cbRet) then
         if cbRet>1 then
          if strlen(pRet)>1 then pInternalName:=Strpas(pRet) else pInternalName:='N/A'
         else pInternalName:='N/A'
        else pInternalName:='N/A';

        strcopy(pc, '\StringFileInfo\040904E4\FileVersion');
        if VerQueryValue(pInformation, pc, pointer(pRet), cbRet) then
         if cbRet>1 then
          if strlen(pRet)>1 then pFileVersion:=Strpas(pRet) else pFileVersion:='N/A'
         else pFileVersion:='N/A'
        else pFileVersion:='N/A';

        strcopy(pc, '\StringFileInfo\040904E4\FileDescription');
        if VerQueryValue(pInformation, pc, pointer(pRet), cbRet) then
         if cbRet>1 then
          if strlen(pRet)>1 then pFileDescription:=Strpas(pRet) else pFileDescription:='N/A'
         else pFileDescription:='N/A'
        else pFileDescription:='N/A';

        strcopy(pc, '\StringFileInfo\040904E4\Comments');
        if VerQueryValue(pInformation, pc, pointer(pRet), cbRet) then
         if cbRet>1 then
          if strlen(pRet)>1 then pComments:=Strpas(pRet) else pComments:='N/A'
         else pComments:='N/A'
        else pComments:='N/A';
        {Set information to screen}
        InternalNameLabel.Lines.add(pInternalName);
        FileVersionLabel.Lines.Add(pFileVersion);
        FileDescriptionLabel.Lines.Add(pFileDescription);
        CommentsLabel.Lines.Add(pComments);
        ProgramVendorLabel.Lines.Add(pVendor);
    end;
    StrDispose(pThisFile);
    StrDispose(pInformation);
end;

procedure TDLLS.CloseButtonClick(Sender: TObject);
Begin
TabbedNotebook1.Enabled:=True;
CheckDLL.Enabled:=True;
Bitbtn1.Enabled:=True;
VersionPanel.Visible:=False;
end;
procedure TDLLS.CheckDLLClick(Sender: TObject);
Begin
     TabbedNotebook1.Enabled:=false;
     VersionPanel.Visible:=True;
     CheckDLL.Enabled:=False;
     Bitbtn1.Enabled:=False;
end;

procedure TDLLS.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     if curhan > HINSTANCE_ERROR then FreeLibrary(curhan);
     VersionPanel.Free;
end;

procedure TDLLS.About1Click(Sender: TObject);
Var
 AboutBox    :TaboutBox;
begin
AboutBox:=TaboutBox.Create(self);
AboutBox.ShowModal;
AboutBox.Free;

end;

procedure TDLLS.Exit1Click(Sender: TObject);
begin
     BitBtn1Click(Self);
end;

procedure TDLLS.Print1Click(Sender: TObject);
Var
pThisPrinter : TPrinter;
Counter      : Integer;
xVar         : Integer;
SubCounter   : Integer;
LineSpacing  : Integer;
CurrentLine  : Integer;
begin
     Screen.Cursor:=crSQLWait;
     SubCounter:=1;

     Try
       Try
          pThisPrinter:=TPrinter.Create;
          if (VersionPanel<>nil) and (VersionPanel.Visible=False) or
             (VersionPanel=Nil)  then
          Begin
               With pThisPrinter do
               Begin
                    BeginDoc;
                    CurrentLine:=0;

                    Canvas.Font.PixelsPerInch :=
                     GetDeviceCaps(Canvas.Handle, LOGPIXELSY);

                    Canvas.Font.Size:=20;
                    LineSpacing:=Trunc(Printer.Canvas.TextHeight('X') * 1.20);
                    {Draw Top Line}
                    CurrentLine:=CurrentLine * LineSpacing;
                    Canvas.MoveTo(0,CurrentLine);
                    Canvas.LineTo(PageWidth,CurrentLine);
                    CurrentLine:=LineSpacing+CurrentLine;
                    {Draw Header Text}
                    xVar:=Canvas.TextWidth('Modules For TeamWorks Diagnostic Utility');
                    xVar:=(PageWidth div 2)-(xVar div 2);
                    Canvas.TextOut(xVar,CurrentLine,'Modules For TeamWorks Diagnostic Utility');
                    CurrentLine:=2*(LineSpacing+(CurrentLine));
                    {Draw Bottom Line}
                    Canvas.MoveTo(0, CurrentLine);
                    Canvas.LineTo(PageWidth, CurrentLine);
                    CurrentLine:=(LineSpacing)+CurrentLine;
                    {Draw Module Type Information}
                    Canvas.Font.Size:=15;
                    LineSpacing:=Trunc(Printer.Canvas.TextHeight('X') * 1.20);
                    Canvas.TextOut(20,CurrentLine,'System Modules');
                    CurrentLine:=LineSpacing+(CurrentLine)+LineSpacing;
                    Canvas.Font.Size:=12;
                    LineSpacing:=Trunc(Printer.Canvas.TextHeight('X') * 1.20);
                    Canvas.TextOut(20,CurrentLine,'List of module type matching: '+
                     ModulesTypes.Items.Strings[ModulesTypes.ItemIndex]);
                    CurrentLine:=LineSpacing+CurrentLine;
                    Canvas.TextOut(20,CurrentLine,'Number of loaded modules: '+Inttostr(ListBox1.Items.Count));
                    {Draw Body Band}
                    CurrentLine:=(LineSpacing+CurrentLine)+LineSpacing;
                    Canvas.TextOut(0,CurrentLine,'#');
                    Canvas.TextOut(Trunc(Printer.Canvas.TextWidth('X') * 5),CurrentLine,'File');
                    CanVas.TextOut(Trunc(Printer.Canvas.TextWidth('X') * 75),CurrentLine,'Version');
                    CurrentLine:=(LineSpacing)+CurrentLine;
                    Canvas.MoveTo(0,CurrentLine);
                    Canvas.LineTo(PageWidth,CurrentLine);
                    CurrentLine:=LineSpacing+CurrentLine;
                    Canvas.Font.Size:=10;
                    LineSpacing:=Trunc(Printer.Canvas.TextHeight('X') * 1.20);
                    {Draw Monule Information}
                    For Counter :=0 to ListBox1.Items.Count-1 do
                    Begin
                       {Write Module}
                       Canvas.TextOut(0,CurrentLine,Inttostr(SubCounter));
                       Canvas.TextOut(Trunc(Printer.Canvas.TextWidth('X') * 5),
                        CurrentLine,ListBox1.Items[Counter]);
                       {Write File Version}
                       Canvas.TextOut(Trunc(Printer.Canvas.TextWidth('X') * 75),
                        CurrentLine,GetFileVersion(ListBox1.Items.Strings[Counter]));
                       if CurrentLine> (PageHeight-(2*(Trunc(Printer.Canvas.TextHeight('X'))))) then
                       Begin
                            {Put Bottom of Page Line}
                            Canvas.MoveTo(0, PageHeight-5);
                            Canvas.LineTo(PageWidth, PageHeight-5);
                            {Add New Page}
                            NewPage;
                            {Insert new header}
                            CurrentLine:=0;

                            Canvas.Font.Size:=20;
                            LineSpacing:=Trunc(Printer.Canvas.TextHeight('X') * 1.20);
                            {Draw Top Line}
                            CurrentLine:=CurrentLine * LineSpacing;
                            Canvas.MoveTo(0,CurrentLine);
                            Canvas.LineTo(PageWidth,CurrentLine);
                            CurrentLine:=LineSpacing+CurrentLine;
                            {Draw Header Text}
                            xVar:=Canvas.TextWidth('Modules For TeamWorks Diagnostic Utility');
                            xVar:=(PageWidth div 2)-(xVar div 2);
                            Canvas.TextOut(xVar,CurrentLine,'Modules For TeamWorks Diagnostic Utility');
                            CurrentLine:=2*(LineSpacing+(CurrentLine));
                            {Draw Bottom Line}
                            Canvas.MoveTo(0, CurrentLine);
                            Canvas.LineTo(PageWidth, CurrentLine);
                            CurrentLine:=(LineSpacing)+CurrentLine;
                            {Draw Module Type Information}
                            Canvas.Font.Size:=15;
                            LineSpacing:=Trunc(Printer.Canvas.TextHeight('X') * 1.20);
                            Canvas.TextOut(20,CurrentLine,'System Modules');
                            Canvas.Font.Size:=12;
                            LineSpacing:=Trunc(Printer.Canvas.TextHeight('X') * 1.20);
                            CurrentLine:=LineSpacing+(CurrentLine)+LineSpacing;
                            Canvas.TextOut(20,CurrentLine,'List of module type matching: '+
                             ModulesTypes.Items.Strings[ModulesTypes.ItemIndex]);
                            CurrentLine:=LineSpacing+CurrentLine;
                            Canvas.TextOut(20,CurrentLine,'Number of loaded modules: '+Inttostr(ListBox1.Items.Count));
                            {Draw Body Band}
                            CurrentLine:=(LineSpacing+CurrentLine)+LineSpacing;
                            Canvas.TextOut(0,CurrentLine,'#');
                            Canvas.TextOut(Trunc(Printer.Canvas.TextWidth('X') * 5),CurrentLine,'File');
                            CanVas.TextOut(Trunc(Printer.Canvas.TextWidth('X') * 75),CurrentLine,'Version');
                            CurrentLine:=(LineSpacing)+CurrentLine;
                            Canvas.MoveTo(0,CurrentLine);
                            Canvas.LineTo(PageWidth,CurrentLine);
                            CurrentLine:=LineSpacing+CurrentLine;
                            Canvas.Font.Size:=10;
                            LineSpacing:=Trunc(Printer.Canvas.TextHeight('X') * 1.20);
                       end;
                       CurrentLine:=LineSpacing+CurrentLine;
                       Inc(SubCounter);
                       if CurrentLine < (PageHeight-100) then
                       Begin
                           {Put Bottom of Page Line}
                           Canvas.MoveTo(0, PageHeight-5);
                           Canvas.LineTo(PageWidth, PageHeight-5);
                       end;
                    end;
                    EndDoc;
               end;
          end
          else
          Begin
               With pThisPrinter do
               Begin
                    BeginDoc;
                    Canvas.Font.PixelsPerInch :=
                     GetDeviceCaps(Canvas.Handle, LOGPIXELSY);
                    Canvas.Font.Size:=20;

                    CurrentLine:=0;
                    LineSpacing:=Trunc(Printer.Canvas.TextHeight('X') * 1.20);

                    {Draw Top Line}
                    Canvas.MoveTo(0, CurrentLine);
                    Canvas.LineTo(PageWidth, CurrentLine);
                    CurrentLine:=(LineSpacing+(CurrentLine));
                    {Draw Header Text}
                    xVar:=Canvas.TextWidth('Modules For TeamWorks Diagnostic Utility');
                    xVar:=(PageWidth div 2)-(xVar div 2);
                    Canvas.TextOut(xVar,CurrentLine,'Modules For TeamWorks Diagnostic Utility');
                    {Draw Bottom Line}
                    CurrentLine:=2*(LineSpacing+(CurrentLine));
                    Canvas.MoveTo(0, CurrentLine);
                    Canvas.LineTo(PageWidth, CurrentLine);
                    {Draw Module Type Information}
                    CurrentLine:=(LineSpacing+(CurrentLine));
                    Canvas.Font.Size:=15;
                    LineSpacing:=Trunc(Printer.Canvas.TextHeight('X') * 1.20);
                    Canvas.TextOut(20,CurrentLine,'TeamWorks Version Compare');
                    CurrentLine:=(LineSpacing+(CurrentLine)+Linespacing);
                    Canvas.Font.Size:=12;
                    LineSpacing:=Trunc(Printer.Canvas.TextHeight('X') * 1.20);
                    Canvas.TextOut(20,CurrentLine,'Number of loaded modules: '+Inttostr(VersionStringGrid.RowCount-1));
                    {Draw Body Band}
                    CurrentLine:=(LineSpacing+(CurrentLine)+LineSpacing);
                    Canvas.TextOut(0,CurrentLine,'#');
                    Canvas.TextOut(Trunc(Printer.Canvas.TextWidth('X') * 5),CurrentLine,'File Name');
                    Canvas.TextOut(Trunc(Printer.Canvas.TextWidth('X') * 30),CurrentLine,'INI Ver.');
                    Canvas.TextOut(Trunc(Printer.Canvas.TextWidth('X') * 45),CurrentLine,'Mem Ver.');
                    Canvas.TextOut(Trunc(Printer.Canvas.TextWidth('X') * 60),CurrentLine,'Check');
                    CurrentLine:=(LineSpacing+(CurrentLine));
                    Canvas.MoveTo(0, CurrentLine);
                    Canvas.LineTo(PageWidth, CurrentLine);
                    CurrentLine:=(LineSpacing+(CurrentLine));
                    Canvas.Font.Size:=10;
                    LineSpacing:=Trunc(Printer.Canvas.TextHeight('X') * 1.20);
                    {Draw Monule Information}
                    For Counter :=1 to VersionStringGrid.RowCount-1 do
                    Begin
                       Canvas.TextOut(0,CurrentLine,Inttostr(SubCounter));
                       Canvas.TextOut(Trunc(Printer.Canvas.TextWidth('X') * 5),CurrentLine,
                        VersionStringGrid.Cells[0,Counter]);
                       Canvas.TextOut(Trunc(Printer.Canvas.TextWidth('X') * 30),CurrentLine,
                        VersionStringGrid.Cells[1,Counter]);
                       Canvas.TextOut(Trunc(Printer.Canvas.TextWidth('X') * 45),
                        CurrentLine,VersionStringGrid.Cells[2,Counter]);
                       Canvas.TextOut(Trunc(Printer.Canvas.TextWidth('X') * 60),
                        CurrentLine,VersionStringGrid.Cells[3,Counter]);
                       if CurrentLine> (PageHeight-(2*(Trunc(Printer.Canvas.TextHeight('X'))))) then
                       Begin
                            {Put Bottom of Page Line}
                            Canvas.MoveTo(0, PageHeight-5);
                            Canvas.LineTo(PageWidth, PageHeight-5);
                            {Add New Page}
                            NewPage;

                            Canvas.Font.Size:=20;
                            CurrentLine:=0;
                            LineSpacing:=Trunc(Printer.Canvas.TextHeight('X') * 1.20);
                            {Draw Top Line}
                            Canvas.MoveTo(0, CurrentLine);
                            Canvas.LineTo(PageWidth, CurrentLine);
                            CurrentLine:=(LineSpacing+(CurrentLine));
                            {Draw Header Text}
                            xVar:=Canvas.TextWidth('Modules For TeamWorks Diagnostic Utility');
                            xVar:=(PageWidth div 2)-(xVar div 2);
                            Canvas.TextOut(xVar,CurrentLine,'Modules For TeamWorks Diagnostic Utility');
                            {Draw Bottom Line}
                            CurrentLine:=2*(LineSpacing+(CurrentLine));
                            Canvas.MoveTo(0, CurrentLine);
                            Canvas.LineTo(PageWidth, CurrentLine);
                            {Draw Module Type Information}
                            CurrentLine:=(LineSpacing+(CurrentLine));
                            Canvas.Font.Size:=15;
                            LineSpacing:=Trunc(Printer.Canvas.TextHeight('X') * 1.20);
                            Canvas.TextOut(20,CurrentLine,'TeamWorks Version Compare');
                            CurrentLine:=(LineSpacing+(CurrentLine));
                            Canvas.Font.Size:=12;
                            LineSpacing:=Trunc(Printer.Canvas.TextHeight('X') * 1.20);
                            Canvas.TextOut(20,CurrentLine,'Number of loaded modules: '+Inttostr(VersionStringGrid.RowCount));
                            {Draw Body Band}
                            CurrentLine:=(LineSpacing+(CurrentLine)+LineSpacing);
                            Canvas.TextOut(0,Currentline,'#');
                            Canvas.TextOut(Trunc(Printer.Canvas.TextWidth('X') * 5),CurrentLine,'File Name');
                            Canvas.TextOut(Trunc(Printer.Canvas.TextWidth('X') * 30),CurrentLine,'INI Ver.');
                            Canvas.TextOut(Trunc(Printer.Canvas.TextWidth('X') * 45),CurrentLine,'Mem Ver.');
                            Canvas.TextOut(Trunc(Printer.Canvas.TextWidth('X') * 60),CurrentLine,'Check');
                            CurrentLine:=(LineSpacing+(CurrentLine));
                            Canvas.MoveTo(0, CurrentLine);
                            Canvas.LineTo(PageWidth, CurrentLine);
                            Canvas.Font.Size:=10;
                            LineSpacing:=Trunc(Printer.Canvas.TextHeight('X') * 1.20);
                       end;
                       CurrentLine:=(LineSpacing+(CurrentLine));
                       Inc(SubCounter);
                       if CurrentLine< (PageHeight-100) then
                       Begin
                           {Put Bottom of Page Line}
                           Canvas.MoveTo(0, PageHeight-5);
                           Canvas.LineTo(PageWidth, PageHeight-5);
                       end;
                    end;
                    EndDoc;
               end;
          end;
       Except
          on E:Exception do MessageDlg(E.Message,mtError,[mbOK],0);
       end;
     Finally
          pThisPrinter.Free;
     end;
     Screen.Cursor:=crDefault;
end;
Function  TDLLS.GetFileVersion (pThisModule: String): String;
Var
    me                     : TModuleEntry;
    Counter                :Integer;
    pThisFile              :Pchar;
    pVersionHandle         :LongInt;
    pInformation           :Pchar;
    pFileVersion           :String;
    VersionInfoSize        :LongInt;
    pc                     :array[0..300] of char;
    pRet                   :pchar;
    cbRet                  :Word;
Begin
    if pThisModule<>'' then
    Begin
        pThisFile:=StrAlloc(300);
        StrPCopy(pThisFile,pThisModule);
        VersionInfoSize := GetFileVersionInfoSize(pThisFile,pVersionHandle);
        if VersionInfoSize<>0 then
        Begin
           pInformation:= Stralloc(VersionInfoSize);
            GetFileVersionInfo(pThisFile,pVersionHandle,VersionInfoSize,pInformation);
            strcopy(pc, '\StringFileInfo\040904E4\FileVersion');
            if VerQueryValue(pInformation, pc, pointer(pRet), cbRet) then
             if cbRet>1 then
              if strlen(pRet)>1 then Result:=Strpas(pRet) else Result:='N/A';
           StrDispose(pInformation);
        end
        else Result:='N/A';
        StrDispose(pThisFile);
    end;
end;
procedure TDLLS.StayonTop1Click(Sender: TObject);
begin
     FormStyle:=fsStayOnTop;
     StayOnTop1.Enabled:=False;
     DoNotStayOnTop1.Enabled:=True;
end;

procedure TDLLS.Donotstayontop1Click(Sender: TObject);
begin
     FormStyle:=fsNormal;
     StayOnTop1.Enabled:=True;
     DoNotStayOnTop1.Enabled:=False;
end;

Procedure TDLLs.FindDrives;
Var
   NextCell  :Integer;
Begin
     NextCell:=1;
     DriveGrid.RowCount:=26;
     DriveGrid.Cells[0,0]:='Drive';
     DriveGrid.Cells[1,0]:='Space left';
     {Check for Free Space}
     With DriveGrid do
     Begin
         if GetDriveType(2)=DRIVE_FIXED then
         Begin
             if DiskFree(3)<>-1 then
             Begin
                  Cells[0,NextCell]:='C';
                  Cells[1,NextCell]:=IntToStr(DiskFree(3));
                  Inc(NextCell);
             end;
         end;
         if GetDriveType(3)=DRIVE_FIXED then
         Begin
             if DiskFree(4)<>-1 then
             Begin
                      Cells[0,NextCell]:='D';
                      Cells[1,NextCell]:=IntToStr(DiskFree(4));
                      Inc(NextCell);
             end;
         end;
         if GetDriveType(4)<>DRIVE_FIXED then
         Begin
              if DiskFree(5)<>-1 then
              Begin
                  Cells[0,NextCell]:='E';
                  Cells[1,NextCell]:=IntToStr(DiskFree(5));
                  Inc(NextCell)
              end;
         end;
         if DiskFree(6)<>-1 then
         Begin
              Cells[0,NextCell]:='F';
              Cells[1,NextCell]:=IntToStr(DiskFree(6));
              Inc(NextCell)
         end;
         if DiskFree(7)<>-1 then
         Begin
              Cells[0,NextCell]:='G';
              Cells[1,NextCell]:=IntToStr(DiskFree(7));
              Inc(NextCell)
         end;
         if DiskFree(8)<>-1 then
         Begin
              Cells[0,NextCell]:='H';
              Cells[1,NextCell]:=IntToStr(DiskFree(8));
              Inc(NextCell)
         end;
         if DiskFree(9)<>-1 then
         Begin
              Cells[0,NextCell]:='I';
              Cells[1,NextCell]:=IntToStr(DiskFree(9));
              Inc(NextCell)
         end;
         if DiskFree(10)<>-1 then
         Begin
              Cells[0,NextCell]:='J';
              Cells[1,NextCell]:=IntToStr(DiskFree(10));
              Inc(NextCell)
         end;
         if DiskFree(11)<>-1 then
         Begin
              Cells[0,NextCell]:='K';
              Cells[1,NextCell]:=IntToStr(DiskFree(11));
              Inc(NextCell)
         end;
         if DiskFree(12)<>-1 then
         Begin
              Cells[0,NextCell]:='L';
              Cells[1,NextCell]:=IntToStr(DiskFree(12));
              Inc(NextCell)
         end;
         if DiskFree(13)<>-1 then
         Begin
              Cells[0,NextCell]:='M';
              Cells[1,NextCell]:=IntToStr(DiskFree(13));
              Inc(NextCell)
         end;
         if DiskFree(14)<>-1 then
         Begin
              Cells[0,NextCell]:='N';
              Cells[1,NextCell]:=IntToStr(DiskFree(14));
              Inc(NextCell)
         end;
         if DiskFree(15)<>-1 then
         Begin
              Cells[0,NextCell]:='O';
              Cells[1,NextCell]:=IntToStr(DiskFree(15));
              Inc(NextCell)
         end;
         if DiskFree(16)<>-1 then
         Begin
              Cells[0,NextCell]:='P';
              Cells[1,NextCell]:=IntToStr(DiskFree(16));
              Inc(NextCell)
         end;
         if DiskFree(17)<>-1 then
         Begin
              Cells[0,NextCell]:='Q';
              Cells[1,NextCell]:=IntToStr(DiskFree(17));
              Inc(NextCell)
         end;
         if DiskFree(18)<>-1 then
         Begin
              Cells[0,NextCell]:='R';
              Cells[1,NextCell]:=IntToStr(DiskFree(18));
              Inc(NextCell)
         end;
         if DiskFree(19)<>-1 then
         Begin
              Cells[0,NextCell]:='S';
              Cells[1,NextCell]:=IntToStr(DiskFree(19));
              Inc(NextCell)
         end;
         if DiskFree(20)<>-1 then
         Begin
              Cells[0,NextCell]:='T';
              Cells[1,NextCell]:=IntToStr(DiskFree(20));
              Inc(NextCell)
         end;
         if DiskFree(21)<>-1 then
         Begin
              Cells[0,NextCell]:='U';
              Cells[1,NextCell]:=IntToStr(DiskFree(21));
              Inc(NextCell)
         end;
         if DiskFree(22)<>-1 then
         Begin
              Cells[0,NextCell]:='V';
              Cells[1,NextCell]:=IntToStr(DiskFree(22));
              Inc(NextCell)
         end;
         if DiskFree(23)<>-1 then
         Begin
              Cells[0,NextCell]:='W';
              Cells[1,NextCell]:=IntToStr(DiskFree(23));
              Inc(NextCell)
         end;
         if DiskFree(24)<>-1 then
         Begin
              Cells[0,NextCell]:='X';
              Cells[1,NextCell]:=IntToStr(DiskFree(24));
              Inc(NextCell)
         end;
         if DiskFree(25)<>-1 then
         Begin
              Cells[0,NextCell]:='Y';
              Cells[1,NextCell]:=IntToStr(DiskFree(25));
              Inc(NextCell)
         end;
         if DiskFree(26)<>-1 then
         Begin
              Cells[0,NextCell]:='Z';
              Cells[1,NextCell]:=IntToStr(DiskFree(26));
              Inc(NextCell)
         end;
         DriveGrid.RowCount:=NextCell;
     end;
end;

procedure TDLLS.FormCreate(Sender: TObject);
Var
pWinDir         :Pchar;
CurrentConfig   :LongInt;
pProc	  	  :TFarProc;
pc              :Pchar;
begin
     {Initiate other Pages}
     {System Information}
     CurrentConfig:=GetWinFlags;
     {CPU TYPE}
     if (CurrentConfig) and (WF_CPU286)=WF_CPU286 then
      CPUtype.Text:='80286'
     else
     if (CurrentConfig) and (WF_CPU386)=WF_CPU386 then
      CPUtype.Text:='80386'
     else
     if (CurrentConfig) and (WF_CPU486)=WF_CPU486 then
      CPUtype.Text:='80486 / Pentium';
     {MAth CoProcessor}
     if (CurrentConfig) and (WF_80x87)=WF_80x87 then
      MathCo.Text:='True' else MathCo.Text:='False';
     {Windows Mode}
     if (CurrentConfig) and (WF_ENHANCED)=WF_ENHANCED then
      WindowsMode.Text:='Enhanced'
     else
     if (CurrentConfig) and (WF_STANDARD)=WF_STANDARD then
      WindowsMode.Text:='Standard'
     else
     if (CurrentConfig) and (WF_PMODE)=WF_PMODE then
      WindowsMode.Text:='Protected';
     {Paged Memory}
     if (CurrentConfig) and (WF_PAGING)=WF_PAGING then
      PagedMemory.Text:='True' else PagedMemory.Text:='False';
     {KeyBoardType}
     Case GetKeyBoardType(0) of
          1: KeyBoardType.Text:='IBM PC/XT, or Compatatible (83 Key) keyboard';
          2: KeyBoardType.Text:='Olivetti ''''ICO'''' (102 Key) keyboard';
          3: KeyBoardType.Text:='IBM AT (84 key) or similar keyboard';
          4: KeyBoardType.Text:='IBM enhanced (101 or 102 key) keyboard';
          5: KeyBoardType.Text:='Nokia 1050 and similar keyboards';
          6: KeyBoardType.Text:='Nokia 9140 and similar keyboard';
          7: KeyBoardType.Text:='Japanese keyboard';
     end;
     {KeyBoard SubType}
     NumberOfKeys.Text:=IntToStr(GetKeyboardType(2));
     {Windows Dir}
     pWinDir:=StrAlloc(300);
     GetWindowsDirectory(pWinDir,300);
     WinDir.Text:=Strpas(pWinDir);
     StrDispose(pWinDir);

     {Try to Load Stress.Dll}
     fStress:=False;
     pc:=StrAlloc(300);
     StrpCopy(pc,'STRESS.DLL');
     curhan := LoadLibrary(pc);
     if curhan > HINSTANCE_ERROR then
     begin
         pProc := GetProcAddress(curhan, 'GETFREEFILEHANDLES');
         if pProc <> NIL then
         begin
             @FileHandles := pProc;
             {Number of Free File Handles}
             fStress:=True
         end;
     end;
     StrDispose(pc);
     if fStress=False then
      FileHandlesLabel.Enabled:=False else FileHandlesLabel.Enabled:=True;
end;




end
.
